Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions
Lucene::OpenBitSetDISI Class Reference

`#include <OpenBitSetDISI.h>`

Inheritance diagram for Lucene::OpenBitSetDISI:

## Public Member Functions

| OpenBitSetDISI (const DocIdSetIteratorPtr &disi, int32_t maxSize)
| Construct an OpenBitSetDISI with its bits set from the doc ids of the given DocIdSetIterator. Also give a maximum size one larger than the largest doc id for which a bit may ever be set on this OpenBitSetDISI. More...
| OpenBitSetDISI (int32_t maxSize)
| Construct an OpenBitSetDISI with no bits set, and a given maximum size one larger than the largest doc id for which a bit may ever be set on this OpenBitSetDISI. More...
virtual | ~OpenBitSetDISI ()
virtual String | getClassName ()
boost::shared_ptr< OpenBitSetDISI > | shared_from_this ()
void | inPlaceOr (const DocIdSetIteratorPtr &disi)
| Perform an in-place OR with the doc ids from a given DocIdSetIterator, setting the bit for each such doc id. These doc ids should be smaller than the maximum size passed to the constructor. More...
void | inPlaceAnd (const DocIdSetIteratorPtr &disi)
| Perform an in-place AND with the doc ids from a given DocIdSetIterator, leaving only the bits set for which the doc ids are in common. These doc ids should be smaller than the maximum size passed to the constructor. More...
void | inPlaceNot (const DocIdSetIteratorPtr &disi)
| Perform an in-place NOT with the doc ids from a given DocIdSetIterator, clearing all the bits for each such doc id. These doc ids should be smaller than the maximum size passed to the constructor. More...
void | inPlaceXor (const DocIdSetIteratorPtr &disi)
| Perform an inplace XOR with the doc ids from a given DocIdSetIterator, flipping all the bits for each such doc id. These doc ids should be smaller than the maximum size passed to the constructor. More...
Public Member Functions inherited from Lucene::OpenBitSet
| OpenBitSet (int64_t numBits=64)
| Constructs an OpenBitSet large enough to hold numBits. More...
| OpenBitSet (LongArray bits, int32_t numWords)
| Constructs an OpenBitSet from an existing LongArray. More...
virtual | ~OpenBitSet ()
boost::shared_ptr< OpenBitSet > | shared_from_this ()
virtual DocIdSetIteratorPtr | iterator ()
| Provides a DocIdSetIterator to access the set. This implementation can return null or EmptyDocIdSet.iterator() if there are no docs that match. More...
virtual bool | isCacheable ()
| This DocIdSet implementation is cacheable. More...
int64_t | capacity ()
| Returns the current capacity in bits (1 greater than the index of the last bit) More...
int64_t | size ()
| Returns the current capacity of this set. Included for compatibility. This is not equal to cardinality. More...
bool | isEmpty ()
| Returns true if there are no set bits. More...
LongArray | getBits ()
| Returns the long[] storing the bits. More...
void | setBits (LongArray bits)
| Sets a new long[] to use as the bit storage. More...
int32_t | getNumWords ()
| Gets the number of longs in the array that are in use. More...
void | setNumWords (int32_t numWords)
| Sets the number of longs in the array that are in use. More...
bool | get (int32_t index)
| Returns true or false for the specified bit index. More...
bool | fastGet (int32_t index)
| Returns true or false for the specified bit index. The index should be less than the OpenBitSet size. More...
bool | get (int64_t index)
| Returns true or false for the specified bit index. More...
bool | fastGet (int64_t index)
| Returns true or false for the specified bit index. The index should be less than the OpenBitSet size. More...
int32_t | getBit (int32_t index)
| Returns 1 if the bit is set, 0 if not. The index should be less than the OpenBitSet size. More...
void | set (int64_t index)
| Sets a bit, expanding the set size if necessary. More...
void | fastSet (int32_t index)
| Sets the bit at the specified index. The index should be less than the OpenBitSet size. More...
void | fastSet (int64_t index)
| Sets the bit at the specified index. The index should be less than the OpenBitSet size. More...
void | set (int64_t startIndex, int64_t endIndex)
| Sets a range of bits, expanding the set size if necessary. More...
void | fastClear (int32_t index)
| Clears a bit. The index should be less than the OpenBitSet size. More...
void | fastClear (int64_t index)
| Clears a bit. The index should be less than the OpenBitSet size. More...
void | clear (int64_t index)
| Clears a bit, allowing access beyond the current set size without changing the size. More...
void | clear (int32_t startIndex, int32_t endIndex)
| Clears a range of bits. Clearing past the end does not change the size of the set. More...
void | clear (int64_t startIndex, int64_t endIndex)
| Clears a range of bits. Clearing past the end does not change the size of the set. More...
bool | getAndSet (int32_t index)
| Sets a bit and returns the previous value. The index should be less than the OpenBitSet size. More...
bool | getAndSet (int64_t index)
| Sets a bit and returns the previous value. The index should be less than the OpenBitSet size. More...
void | fastFlip (int32_t index)
| Flips a bit. The index should be less than the OpenBitSet size. More...
void | fastFlip (int64_t index)
| Flips a bit. The index should be less than the OpenBitSet size. More...
void | flip (int64_t index)
| Flips a bit, expanding the set size if necessary. More...
bool | flipAndGet (int32_t index)
| Flips a bit and returns the resulting bit value. The index should be less than the OpenBitSet size. More...
bool | flipAndGet (int64_t index)
| Flips a bit and returns the resulting bit value. The index should be less than the OpenBitSet size. More...
void | flip (int64_t startIndex, int64_t endIndex)
| Flips a range of bits, expanding the set size if necessary. More...
int64_t | cardinality ()
int32_t | nextSetBit (int32_t index)
| Returns the index of the first set bit starting at the index specified. -1 is returned if there are no more set bits. More...
int64_t | nextSetBit (int64_t index)
| Returns the index of the first set bit starting at the index specified. -1 is returned if there are no more set bits. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
void | intersect (const OpenBitSetPtr &other)
| this = this AND other More...
void | _union (const OpenBitSetPtr &other)
| this = this OR other More...
void | remove (const OpenBitSetPtr &other)
| Remove all elements set in other. this = this AND_NOT other. More...
void | _xor (const OpenBitSetPtr &other)
| this = this XOR other More...
void | _and (const OpenBitSetPtr &other)
| see intersect More...
void | _or (const OpenBitSetPtr &other)
| see union More...
void | andNot (const OpenBitSetPtr &other)
| see remove More...
bool | intersects (const OpenBitSetPtr &other)
| Returns true if the sets have any elements in common. More...
void | ensureCapacityWords (int32_t numWords)
| Expand the LongArray with the size given as a number of words (64 bit longs). getNumWords() is unchanged by this call. More...
void | ensureCapacity (int64_t numBits)
| Ensure that the LongArray is big enough to hold numBits, expanding it if necessary. getNumWords() is unchanged by this call. More...
void | trimTrailingZeros ()
| Lowers numWords, the number of words in use, by checking for trailing zero words. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Returns true if both sets have the same bits set. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
Public Member Functions inherited from Lucene::DocIdSet
virtual | ~DocIdSet ()
boost::shared_ptr< DocIdSet > | shared_from_this ()
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::OpenBitSet
static String | _getClassName ()
static int64_t | intersectionCount (const OpenBitSetPtr &a, const OpenBitSetPtr &b)
| Returns the popcount or cardinality of the intersection of the two sets. Neither set is modified. More...
static int64_t | unionCount (const OpenBitSetPtr &a, const OpenBitSetPtr &b)
| Returns the popcount or cardinality of the union of the two sets. Neither set is modified. More...
static int64_t | andNotCount (const OpenBitSetPtr &a, const OpenBitSetPtr &b)
| Returns the popcount or cardinality of "a and not b" or "intersection(a, not(b))". Neither set is modified. More...
static int64_t | xorCount (const OpenBitSetPtr &a, const OpenBitSetPtr &b)
| Returns the popcount or cardinality of the exclusive-or of the two sets. Neither set is modified. More...
static int32_t | bits2words (int64_t numBits)
| Returns the number of 64 bit words it would take to hold numBits. More...
Static Public Member Functions inherited from Lucene::DocIdSet
static String | _getClassName ()
static DocIdSetPtr | EMPTY_DOCIDSET ()
| An empty {. More...

## Additional Inherited Members

Protected Member Functions inherited from Lucene::OpenBitSet
int32_t | expandingWordNum (int64_t index)
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()
Protected Attributes inherited from Lucene::OpenBitSet
LongArray | bits
int32_t | wlen
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Constructor & Destructor Documentation

Lucene::OpenBitSetDISI::OpenBitSetDISI | ( | const DocIdSetIteratorPtr & | disi,
|  | int32_t | maxSize
| ) |  |

Construct an OpenBitSetDISI with its bits set from the doc ids of the given DocIdSetIterator. Also give a maximum size one larger than the largest doc id for which a bit may ever be set on this OpenBitSetDISI.

Lucene::OpenBitSetDISI::OpenBitSetDISI | ( | int32_t | maxSize | ) |

Construct an OpenBitSetDISI with no bits set, and a given maximum size one larger than the largest doc id for which a bit may ever be set on this OpenBitSetDISI.

virtual Lucene::OpenBitSetDISI::~OpenBitSetDISI | ( |  | ) |

virtual

## Member Function Documentation

static String Lucene::OpenBitSetDISI::_getClassName | ( |  | ) |

inline static

virtual String Lucene::OpenBitSetDISI::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::OpenBitSet.

void Lucene::OpenBitSetDISI::inPlaceAnd | ( | const DocIdSetIteratorPtr & | disi | ) |

Perform an in-place AND with the doc ids from a given DocIdSetIterator, leaving only the bits set for which the doc ids are in common. These doc ids should be smaller than the maximum size passed to the constructor.

void Lucene::OpenBitSetDISI::inPlaceNot | ( | const DocIdSetIteratorPtr & | disi | ) |

Perform an in-place NOT with the doc ids from a given DocIdSetIterator, clearing all the bits for each such doc id. These doc ids should be smaller than the maximum size passed to the constructor.

void Lucene::OpenBitSetDISI::inPlaceOr | ( | const DocIdSetIteratorPtr & | disi | ) |

Perform an in-place OR with the doc ids from a given DocIdSetIterator, setting the bit for each such doc id. These doc ids should be smaller than the maximum size passed to the constructor.

void Lucene::OpenBitSetDISI::inPlaceXor | ( | const DocIdSetIteratorPtr & | disi | ) |

Perform an inplace XOR with the doc ids from a given DocIdSetIterator, flipping all the bits for each such doc id. These doc ids should be smaller than the maximum size passed to the constructor.

boost::shared_ptr< OpenBitSetDISI > Lucene::OpenBitSetDISI::shared_from_this | ( |  | ) |

inline

The documentation for this class was generated from the following file:

- OpenBitSetDISI.h

clucene.sourceforge.net